Index: branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Optimization.Views/3.3/ProblemInstanceProviderView.Designer.cs
===================================================================
--- branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Optimization.Views/3.3/ProblemInstanceProviderView.Designer.cs	(revision 7754)
+++ 	(revision )
@@ -1,151 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Optimization.Views {
-  partial class ProblemInstanceProviderView<T> {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.components = new System.ComponentModel.Container();
-      this.loadButton = new System.Windows.Forms.Button();
-      this.instanceLabel = new System.Windows.Forms.Label();
-      this.instancesComboBox = new System.Windows.Forms.ComboBox();
-      this.importButton = new System.Windows.Forms.Button();
-      this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
-      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
-      this.exportButton = new System.Windows.Forms.Button();
-      this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
-      this.SuspendLayout();
-      // 
-      // loadButton
-      // 
-      this.loadButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.loadButton.Location = new System.Drawing.Point(601, -1);
-      this.loadButton.Name = "loadButton";
-      this.loadButton.Size = new System.Drawing.Size(26, 23);
-      this.loadButton.TabIndex = 6;
-      this.loadButton.Text = "Load";
-      this.loadButton.UseVisualStyleBackColor = true;
-      this.loadButton.Click += new System.EventHandler(this.loadButton_Click);
-      // 
-      // instanceLabel
-      // 
-      this.instanceLabel.AutoSize = true;
-      this.instanceLabel.Location = new System.Drawing.Point(-3, 3);
-      this.instanceLabel.Name = "instanceLabel";
-      this.instanceLabel.Size = new System.Drawing.Size(51, 13);
-      this.instanceLabel.TabIndex = 4;
-      this.instanceLabel.Text = "Instance:";
-      // 
-      // instancesComboBox
-      // 
-      this.instancesComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.instancesComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.instancesComboBox.FormattingEnabled = true;
-      this.instancesComboBox.Location = new System.Drawing.Point(54, 0);
-      this.instancesComboBox.Name = "instancesComboBox";
-      this.instancesComboBox.Size = new System.Drawing.Size(541, 21);
-      this.instancesComboBox.TabIndex = 7;
-      this.instancesComboBox.DataSourceChanged += new System.EventHandler(this.comboBox_DataSourceChanged);
-      // 
-      // importButton
-      // 
-      this.importButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.importButton.Location = new System.Drawing.Point(633, -1);
-      this.importButton.Name = "importButton";
-      this.importButton.Size = new System.Drawing.Size(26, 23);
-      this.importButton.TabIndex = 6;
-      this.importButton.Text = "Import";
-      this.importButton.TextImageRelation = System.Windows.Forms.TextImageRelation.ImageBeforeText;
-      this.importButton.UseVisualStyleBackColor = true;
-      this.importButton.Click += new System.EventHandler(this.importButton_Click);
-      // 
-      // openFileDialog
-      // 
-      this.openFileDialog.Filter = "All files|*.*";
-      // 
-      // exportButton
-      // 
-      this.exportButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.exportButton.Location = new System.Drawing.Point(665, -1);
-      this.exportButton.Name = "exportButton";
-      this.exportButton.Size = new System.Drawing.Size(26, 23);
-      this.exportButton.TabIndex = 8;
-      this.exportButton.Text = "Export";
-      this.exportButton.TextImageRelation = System.Windows.Forms.TextImageRelation.ImageBeforeText;
-      this.exportButton.UseVisualStyleBackColor = true;
-      this.exportButton.Click += new System.EventHandler(this.exportButton_Click);
-      // 
-      // saveFileDialog
-      // 
-      this.saveFileDialog.Filter = "CSV files|*.csv|All files|*.*";
-      this.saveFileDialog.Title = "Save RegressionInstance...";
-      // 
-      // ProblemInstanceProviderView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.exportButton);
-      this.Controls.Add(this.instancesComboBox);
-      this.Controls.Add(this.importButton);
-      this.Controls.Add(this.loadButton);
-      this.Controls.Add(this.instanceLabel);
-      this.Name = "ProblemInstanceProviderView";
-      this.Size = new System.Drawing.Size(694, 21);
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.OpenFileDialog openFileDialog;
-    private System.Windows.Forms.ToolTip toolTip;
-    protected System.Windows.Forms.Button loadButton;
-    protected System.Windows.Forms.Label instanceLabel;
-    protected System.Windows.Forms.ComboBox instancesComboBox;
-    protected System.Windows.Forms.Button importButton;
-    protected System.Windows.Forms.Button exportButton;
-    private System.Windows.Forms.SaveFileDialog saveFileDialog;
-
-  }
-}
Index: branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Optimization.Views/3.3/ProblemInstanceProviderView.cs
===================================================================
--- branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Optimization.Views/3.3/ProblemInstanceProviderView.cs	(revision 7754)
+++ 	(revision )
@@ -1,128 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.IO;
-using System.Linq;
-using System.Windows.Forms;
-using HeuristicLab.Common.Resources;
-using HeuristicLab.MainForm;
-using HeuristicLab.MainForm.WindowsForms;
-using HeuristicLab.PluginInfrastructure;
-using HeuristicLab.Problems.Instances;
-
-namespace HeuristicLab.Optimization.Views {
-  [View("ProblemInstanceProviderView")]
-  [Content(typeof(IProblemInstanceProvider<>), IsDefaultView = false)]
-  public partial class ProblemInstanceProviderView<T> : AsynchronousContentView {
-
-    public new IProblemInstanceProvider<T> Content {
-      get { return (IProblemInstanceProvider<T>)base.Content; }
-      set { base.Content = value; }
-    }
-
-    public ProblemInstanceProviderView() {
-      InitializeComponent();
-      importButton.Text = String.Empty;
-      importButton.Image = VSImageLibrary.Open;
-      toolTip.SetToolTip(importButton, "Import a " + GetProblemType() + " instance from file.");
-      exportButton.Text = String.Empty;
-      exportButton.Image = VSImageLibrary.Save;
-      toolTip.SetToolTip(exportButton, "Export a " + GetProblemType() + " instance to a file.");
-      loadButton.Text = String.Empty;
-      loadButton.Image = VSImageLibrary.RefreshDocument;
-      toolTip.SetToolTip(loadButton, "Load the selected instance.");
-    }
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      if (Content == null) {
-        instancesComboBox.DataSource = null;
-      } else {
-        instancesComboBox.DisplayMember = "Name";
-        instancesComboBox.DataSource = Content.GetDataDescriptors().ToList();
-      }
-    }
-
-    protected override void SetEnabledStateOfControls() {
-      base.SetEnabledStateOfControls();
-      instancesComboBox.Enabled = !ReadOnly && !Locked && Content != null && Content.Consumer != null;
-      loadButton.Enabled = !ReadOnly && !Locked && Content != null && Content.Consumer != null;
-    }
-
-    protected virtual void loadButton_Click(object sender, EventArgs e) {
-      var descriptor = (IDataDescriptor)instancesComboBox.SelectedItem;
-      var instance = Content.LoadData(descriptor);
-      try {
-        Content.Consumer.Load(instance);
-      }
-      catch (Exception ex) {
-        MessageBox.Show(String.Format("This problem does not support loading the instance {0}: {1}", descriptor.Name, Environment.NewLine + ex.Message), "Cannot load instance");
-      }
-    }
-
-    protected virtual void importButton_Click(object sender, EventArgs e) {
-      openFileDialog.FileName = GetProblemType() + " instance";
-      if (openFileDialog.ShowDialog() == DialogResult.OK) {
-        T instance = default(T);
-        try {
-          instance = Content.LoadData(openFileDialog.FileName);
-        }
-        catch (Exception ex) {
-          MessageBox.Show(String.Format("There was an error parsing the file: {0}", Environment.NewLine + ex.Message), "Error while parsing", MessageBoxButtons.OK, MessageBoxIcon.Error);
-          return;
-        }
-        try {
-          Content.Consumer.Load(instance);
-        }
-        catch (Exception ex) {
-          MessageBox.Show(String.Format("This problem does not support loading the instance {0}: {1}", Path.GetFileName(openFileDialog.FileName), Environment.NewLine + ex.Message), "Cannot load instance");
-        }
-      }
-    }
-
-    protected virtual void exportButton_Click(object sender, EventArgs e) {
-      if (saveFileDialog.ShowDialog(this) == DialogResult.OK) {
-        try {
-          var descriptor = (IDataDescriptor)instancesComboBox.SelectedItem;
-          var instance = Content.LoadData(descriptor);
-          Content.SaveData(instance, saveFileDialog.FileName);
-        }
-        catch (Exception ex) {
-          ErrorHandling.ShowErrorDialog(this, ex);
-        }
-      }
-    }
-
-    private void comboBox_DataSourceChanged(object sender, EventArgs e) {
-      var comboBox = (ComboBox)sender;
-      if (comboBox.DataSource == null)
-        comboBox.Items.Clear();
-    }
-
-    protected virtual string GetProblemType() {
-      string dataTypeName = typeof(T).Name.Split(new char[] { '.' }, StringSplitOptions.RemoveEmptyEntries).Last();
-      if (dataTypeName.EndsWith("Data"))
-        return dataTypeName.Substring(0, dataTypeName.Length - "Data".Length);
-      else return dataTypeName;
-    }
-  }
-}
Index: branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Problems.Instances/3.3/IExportable.cs
===================================================================
--- branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Problems.Instances/3.3/IExportable.cs	(revision 7754)
+++ 	(revision )
@@ -1,26 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Problems.Instances {
-  public interface IExportable<TData> {
-    void ExportTo(TData data);
-  }
-}