Index: branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Optimization.Views/3.3/RunView.cs
===================================================================
--- branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Optimization.Views/3.3/RunView.cs	(revision 7770)
+++ branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Optimization.Views/3.3/RunView.cs	(revision 7771)
@@ -44,9 +44,4 @@
     }
 
-    public override bool ReadOnly {
-      get { return true; }
-      set { /*not needed because runs are always readonly */}
-    }
-
     /// <summary>
     /// Initializes a new instance of <see cref="VariableView"/> with caption "Variable".
@@ -83,8 +78,11 @@
       listView.Enabled = Content != null;
       detailsGroupBox.Enabled = (Content != null) && (listView.SelectedItems.Count == 1);
-      viewHost.Enabled = Content != null;
-      viewHost.ReadOnly = ReadOnly;
       changeColorButton.Enabled = Content != null;
       showAlgorithmButton.Enabled = Content != null && Content.Algorithm != null && !Locked;
+    }
+
+    protected override void PropagateStateChanges(Control control, Type type, System.Reflection.PropertyInfo propertyInfo) {
+      if (propertyInfo.Name == "ReadOnly") return;
+      base.PropagateStateChanges(control, type, propertyInfo);
     }
 
Index: branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Problems.DataAnalysis.Views/3.4/MenuItems/CreateEnsembleMenuItem.cs
===================================================================
--- branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Problems.DataAnalysis.Views/3.4/MenuItems/CreateEnsembleMenuItem.cs	(revision 7770)
+++ branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Problems.DataAnalysis.Views/3.4/MenuItems/CreateEnsembleMenuItem.cs	(revision 7771)
@@ -73,5 +73,5 @@
               .First()
               .ProblemData.Clone();
-            var ensemble = new RegressionEnsembleSolution(Enumerable.Empty<IRegressionModel>(), problemData);
+            var ensemble = new RegressionEnsembleSolution(problemData);
             ensemble.Name = group.Key + " ensemble";
             var nestedSolutions = group.OfType<RegressionEnsembleSolution>().SelectMany(e => e.RegressionSolutions);
Index: branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionErrorCharacteristicsCurveView.Designer.cs
===================================================================
--- branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionErrorCharacteristicsCurveView.Designer.cs	(revision 7770)
+++ branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionErrorCharacteristicsCurveView.Designer.cs	(revision 7771)
@@ -49,5 +49,6 @@
       this.chart.TabIndex = 0;
       this.chart.Text = "chart";
-      this.chart.MouseDown += new System.Windows.Forms.MouseEventHandler(this.chart_MouseDown);
+      this.chart.MouseDoubleClick += new System.Windows.Forms.MouseEventHandler(this.Chart_MouseDoubleClick);
+      this.chart.MouseMove += new System.Windows.Forms.MouseEventHandler(this.chart_MouseMove);
       // 
       // label1
Index: branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionErrorCharacteristicsCurveView.cs
===================================================================
--- branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionErrorCharacteristicsCurveView.cs	(revision 7770)
+++ branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionErrorCharacteristicsCurveView.cs	(revision 7771)
@@ -27,4 +27,5 @@
 using HeuristicLab.MainForm;
 using HeuristicLab.MainForm.WindowsForms;
+
 namespace HeuristicLab.Problems.DataAnalysis.Views {
   [View("Error Characteristics Curve")]
@@ -104,17 +105,17 @@
       var originalValues = GetOriginalValues().ToList();
       constantModel = CreateConstantModel();
-      var meanModelEstimatedValues = GetEstimatedValues(constantModel);
-      var meanModelResiduals = GetResiduals(originalValues, meanModelEstimatedValues);
-
-      meanModelResiduals.Sort();
-      chart.ChartAreas[0].AxisX.Maximum = Math.Ceiling(meanModelResiduals.Last());
-      chart.ChartAreas[0].CursorX.Interval = meanModelResiduals.First() / 100;
-
-      Series meanModelSeries = new Series("Mean Model");
-      meanModelSeries.ChartType = SeriesChartType.FastLine;
-      UpdateSeries(meanModelResiduals, meanModelSeries);
-      meanModelSeries.ToolTip = "Area over Curve: " + CalculateAreaOverCurve(meanModelSeries);
-      meanModelSeries.Tag = constantModel;
-      chart.Series.Add(meanModelSeries);
+      var baselineEstimatedValues = GetEstimatedValues(constantModel);
+      var baselineResiduals = GetResiduals(originalValues, baselineEstimatedValues);
+
+      baselineResiduals.Sort();
+      chart.ChartAreas[0].AxisX.Maximum = Math.Ceiling(baselineResiduals.Last());
+      chart.ChartAreas[0].CursorX.Interval = baselineResiduals.First() / 100;
+
+      Series baselineSeries = new Series("Baseline");
+      baselineSeries.ChartType = SeriesChartType.FastLine;
+      UpdateSeries(baselineResiduals, baselineSeries);
+      baselineSeries.ToolTip = "Area over Curve: " + CalculateAreaOverCurve(baselineSeries);
+      baselineSeries.Tag = constantModel;
+      chart.Series.Add(baselineSeries);
 
       AddRegressionSolution(Content);
@@ -200,5 +201,5 @@
     }
 
-    protected IEnumerable<double> GetMeanModelEstimatedValues(IEnumerable<double> originalValues) {
+    protected IEnumerable<double> GetbaselineEstimatedValues(IEnumerable<double> originalValues) {
       double averageTrainingTarget = ProblemData.Dataset.GetDoubleValues(ProblemData.TargetVariable, ProblemData.TrainingIndizes).Average();
       return Enumerable.Repeat(averageTrainingTarget, originalValues.Count());
@@ -229,10 +230,8 @@
     }
 
-    #region Mean Model
-    private void chart_MouseDown(object sender, MouseEventArgs e) {
-      if (e.Clicks < 2) return;
+    #region Baseline
+    private void Chart_MouseDoubleClick(object sender, MouseEventArgs e) {
       HitTestResult result = chart.HitTest(e.X, e.Y);
       if (result.ChartElementType != ChartElementType.LegendItem) return;
-      if (result.Series.Name != constantModel.Name) return;
 
       MainFormManager.MainForm.ShowContent((IRegressionSolution)result.Series.Tag);
@@ -242,8 +241,16 @@
       double averageTrainingTarget = ProblemData.Dataset.GetDoubleValues(ProblemData.TargetVariable, ProblemData.TrainingIndizes).Average();
       var solution = new ConstantRegressionModel(averageTrainingTarget).CreateRegressionSolution(ProblemData);
-      solution.Name = "Mean Model";
+      solution.Name = "Baseline";
       return solution;
     }
     #endregion
+
+    private void chart_MouseMove(object sender, MouseEventArgs e) {
+      HitTestResult result = chart.HitTest(e.X, e.Y);
+      if (result.ChartElementType == ChartElementType.LegendItem)
+        Cursor = Cursors.Hand;
+      else
+        Cursor = Cursors.Default;
+    }
   }
 }
Index: branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Problems.Instances/3.3/HeuristicLab.Problems.Instances-3.3.csproj
===================================================================
--- branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Problems.Instances/3.3/HeuristicLab.Problems.Instances-3.3.csproj	(revision 7770)
+++ branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Problems.Instances/3.3/HeuristicLab.Problems.Instances-3.3.csproj	(revision 7771)
@@ -18,5 +18,5 @@
     <DebugType>full</DebugType>
     <Optimize>false</Optimize>
-    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <OutputPath>..\..\bin\</OutputPath>
     <DefineConstants>DEBUG;TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
@@ -26,5 +26,5 @@
     <DebugType>pdbonly</DebugType>
     <Optimize>true</Optimize>
-    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <OutputPath>..\..\bin\</OutputPath>
     <DefineConstants>TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
@@ -43,5 +43,5 @@
     <DebugType>full</DebugType>
     <PlatformTarget>x64</PlatformTarget>
-    <CodeAnalysisLogFile>..\..\..\..\trunk\sources\bin\HeuristicLab.Problems.Instances-3.3.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisLogFile>..\..\bin\HeuristicLab.Problems.Instances-3.3.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
     <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
     <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
@@ -60,5 +60,5 @@
     <DebugType>pdbonly</DebugType>
     <PlatformTarget>x64</PlatformTarget>
-    <CodeAnalysisLogFile>..\..\..\..\trunk\sources\bin\HeuristicLab.Problems.Instances-3.3.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisLogFile>..\..\bin\HeuristicLab.Problems.Instances-3.3.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
     <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
     <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
@@ -77,5 +77,5 @@
     <DebugType>full</DebugType>
     <PlatformTarget>x86</PlatformTarget>
-    <CodeAnalysisLogFile>..\..\..\..\trunk\sources\bin\HeuristicLab.Problems.Instances-3.3.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisLogFile>..\..\bin\HeuristicLab.Problems.Instances-3.3.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
     <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
     <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
@@ -94,5 +94,5 @@
     <DebugType>pdbonly</DebugType>
     <PlatformTarget>x86</PlatformTarget>
-    <CodeAnalysisLogFile>..\..\..\..\trunk\sources\bin\HeuristicLab.Problems.Instances-3.3.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisLogFile>..\..\bin\HeuristicLab.Problems.Instances-3.3.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
     <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
     <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
Index: branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/QAPVisualizationControl.cs
===================================================================
--- branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/QAPVisualizationControl.cs	(revision 7770)
+++ branches/ProblemInstancesRegressionAndClassification/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/QAPVisualizationControl.cs	(revision 7771)
@@ -308,5 +308,5 @@
         using (Graphics graphics = Graphics.FromImage(newBitmap)) {
           graphics.Clear(Color.White);
-          graphics.DrawString("Showing locations spaced out according to their distances", Font, Brushes.Black, 5, 2);
+          graphics.DrawString("Showing locations layed out according to their distances", Font, Brushes.Black, 5, 2);
 
           for (int i = 0; i < coordinates.Rows - 1; i++) {
@@ -402,5 +402,5 @@
         using (Graphics graphics = Graphics.FromImage(newBitmap)) {
           graphics.Clear(Color.White);
-          graphics.DrawString("Showing facilities spaced out according to their weights", Font, Brushes.Black, 5, 2);
+          graphics.DrawString("Showing facilities layed out according to their weights", Font, Brushes.Black, 5, 2);
 
           for (int i = 0; i < coordinates.Rows - 1; i++) {