Index: /trunk/sources/HeuristicLab.Clients.Hive.Slave.ConsoleClient/3.3/app.config
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Slave.ConsoleClient/3.3/app.config	(revision 7776)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Slave.ConsoleClient/3.3/app.config	(revision 7777)
@@ -1,4 +1,9 @@
 <?xml version="1.0"?>
 <configuration>
+  <configSections>
+    <sectionGroup name="userSettings" type="System.Configuration.UserSettingsGroup, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" >
+      <section name="HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings" type="System.Configuration.ClientSettingsSection, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" allowExeDefinition="MachineToLocalUser" requirePermission="false" />
+    </sectionGroup>
+  </configSections>
   <runtime>
     <gcServer enabled="true" />
@@ -46,3 +51,80 @@
    
  </system.serviceModel>
+  
+  <userSettings>
+    <HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
+      <setting name="HeartbeatInterval" serializeAs="String">
+        <value>00:00:20</value>
+      </setting>
+      <setting name="LastUsedFileName" serializeAs="String">
+        <value>lastUsed.dat</value>
+      </setting>
+      <setting name="PluginCacheDir" serializeAs="String">
+        <value>PluginCache</value>
+      </setting>
+      <setting name="PluginTempBaseDir" serializeAs="String">
+        <value>PluginTemp</value>
+      </setting>
+      <setting name="ConfigurationName" serializeAs="String">
+        <value>Configuration</value>
+      </setting>
+      <setting name="PluginInfrastructureDll" serializeAs="String">
+        <value>HeuristicLab.PluginInfrastructure-3.3.dll</value>
+      </setting>
+      <setting name="SharpZipLibDll" serializeAs="String">
+        <value>ICSharpCode.SharpZipLib.dll</value>
+      </setting>
+      <setting name="SharpZipLibLicense" serializeAs="String">
+        <value>ICSharpCode.SharpZipLib License.txt</value>
+      </setting>
+      <setting name="ClientsHiveSlaveCoreDll" serializeAs="String">
+        <value>HeuristicLab.Clients.Hive.SlaveCore-3.3.dll</value>
+      </setting>
+      <setting name="ClientsHiveDll" serializeAs="String">
+        <value>HeuristicLab.Clients.Hive-3.3.dll</value>
+      </setting>
+      <setting name="HiveDll" serializeAs="String">
+        <value>HeuristicLab.Hive-3.3.dll</value>
+      </setting>
+      <setting name="ClientsCommonDll" serializeAs="String">
+        <value>HeuristicLab.Clients.Common-3.3.dll</value>
+      </setting>
+      <setting name="PluginLifetime" serializeAs="String">
+        <value>3</value>
+      </setting>
+      <setting name="DirOpSleepTime" serializeAs="String">
+        <value>00:00:01</value>
+      </setting>
+      <setting name="PluginDeletionRetries" serializeAs="String">
+        <value>5</value>
+      </setting>
+      <setting name="PluginDeletionTimeout" serializeAs="String">
+        <value>00:00:01</value>
+      </setting>
+      <setting name="ExecutorSemTimeouts" serializeAs="String">
+        <value>00:00:46</value>
+      </setting>
+      <setting name="QueuesMaxThreads" serializeAs="String">
+        <value>5000</value>
+      </setting>
+      <setting name="SlaveCommunicationServiceEndpoint" serializeAs="String">
+        <value>SlaveCommunicationServiceEndpoint</value>
+      </setting>
+      <setting name="SlaveUser" serializeAs="String">
+        <value>hiveslave</value>
+      </setting>
+      <setting name="SlavePwd" serializeAs="String">
+        <value>hiveslave</value>
+      </setting>
+      <setting name="MaxLogCount" serializeAs="String">
+        <value>1</value>
+      </setting>
+      <setting name="ExecutorQueueTimeout" serializeAs="String">
+        <value>00:00:20</value>
+      </setting>
+      <setting name="NrOfCoresToScavenge" serializeAs="String">
+        <value>2</value>
+      </setting>
+   </HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
+  </userSettings>
 <startup><supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.0"/></startup></configuration>
Index: /trunk/sources/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/app.config
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/app.config	(revision 7776)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/app.config	(revision 7777)
@@ -1,4 +1,9 @@
 <?xml version="1.0"?>
 <configuration>
+  <configSections>
+    <sectionGroup name="userSettings" type="System.Configuration.UserSettingsGroup, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" >
+      <section name="HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings" type="System.Configuration.ClientSettingsSection, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" allowExeDefinition="MachineToLocalUser" requirePermission="false" />
+    </sectionGroup>
+  </configSections>
   <runtime>
     <gcServer enabled="true" />
@@ -39,4 +44,82 @@
 
   </system.serviceModel>
+
+  <userSettings>
+    <HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
+      <setting name="HeartbeatInterval" serializeAs="String">
+        <value>00:00:60</value>
+      </setting>
+      <setting name="LastUsedFileName" serializeAs="String">
+        <value>lastUsed.dat</value>
+      </setting>
+      <setting name="PluginCacheDir" serializeAs="String">
+        <value>PluginCache</value>
+      </setting>
+      <setting name="PluginTempBaseDir" serializeAs="String">
+        <value>PluginTemp</value>
+      </setting>
+      <setting name="ConfigurationName" serializeAs="String">
+        <value>Configuration</value>
+      </setting>
+      <setting name="PluginInfrastructureDll" serializeAs="String">
+        <value>HeuristicLab.PluginInfrastructure-3.3.dll</value>
+      </setting>
+      <setting name="SharpZipLibDll" serializeAs="String">
+        <value>ICSharpCode.SharpZipLib.dll</value>
+      </setting>
+      <setting name="SharpZipLibLicense" serializeAs="String">
+        <value>ICSharpCode.SharpZipLib License.txt</value>
+      </setting>
+      <setting name="ClientsHiveSlaveCoreDll" serializeAs="String">
+        <value>HeuristicLab.Clients.Hive.SlaveCore-3.3.dll</value>
+      </setting>
+      <setting name="ClientsHiveDll" serializeAs="String">
+        <value>HeuristicLab.Clients.Hive-3.3.dll</value>
+      </setting>
+      <setting name="HiveDll" serializeAs="String">
+        <value>HeuristicLab.Hive-3.3.dll</value>
+      </setting>
+      <setting name="ClientsCommonDll" serializeAs="String">
+        <value>HeuristicLab.Clients.Common-3.3.dll</value>
+      </setting>
+      <setting name="PluginLifetime" serializeAs="String">
+        <value>3</value>
+      </setting>
+      <setting name="DirOpSleepTime" serializeAs="String">
+        <value>00:00:01</value>
+      </setting>
+      <setting name="PluginDeletionRetries" serializeAs="String">
+        <value>5</value>
+      </setting>
+      <setting name="PluginDeletionTimeout" serializeAs="String">
+        <value>00:00:01</value>
+      </setting>
+      <setting name="ExecutorSemTimeouts" serializeAs="String">
+        <value>00:00:46</value>
+      </setting>
+      <setting name="QueuesMaxThreads" serializeAs="String">
+        <value>5000</value>
+      </setting>
+      <setting name="SlaveCommunicationServiceEndpoint" serializeAs="String">
+        <value>SlaveCommunicationServiceEndpoint</value>
+      </setting>
+      <setting name="SlaveUser" serializeAs="String">
+        <value>hiveslave</value>
+      </setting>
+      <setting name="SlavePwd" serializeAs="String">
+        <value>hiveslave</value>
+      </setting>
+      <setting name="MaxLogCount" serializeAs="String">
+        <value>1</value>
+      </setting>
+      <setting name="ExecutorQueueTimeout" serializeAs="String">
+        <value>00:00:20</value>
+      </setting>
+      <setting name="NrOfCoresToScavenge" serializeAs="String">
+        <value>-1</value>
+      </setting>
+    </HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
+  </userSettings>
+  
   <startup>
     <supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.0"/>
Index: /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Manager/ConfigManager.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Manager/ConfigManager.cs	(revision 7776)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Manager/ConfigManager.cs	(revision 7777)
@@ -63,5 +63,9 @@
       slave.Id = GetUniqueMachineId();
       slave.Name = Environment.MachineName;
-      slave.Cores = Environment.ProcessorCount;
+      if (Settings.Default.NrOfCoresToScavenge < 1 || Settings.Default.NrOfCoresToScavenge > Environment.ProcessorCount) {
+        slave.Cores = Environment.ProcessorCount;
+      } else {
+        slave.Cores = Settings.Default.NrOfCoresToScavenge;
+      }
       slave.Memory = GetPhysicalMemory();
       slave.CpuArchitecture = Environment.Is64BitOperatingSystem ? CpuArchitecture.x64 : CpuArchitecture.x86;
Index: /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.Designer.cs	(revision 7776)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.Designer.cs	(revision 7777)
@@ -2,5 +2,5 @@
 // <auto-generated>
 //     This code was generated by a tool.
-//     Runtime Version:4.0.30319.239
+//     Runtime Version:4.0.30319.530
 //
 //     Changes to this file may cause incorrect behavior and will be lost if
@@ -26,5 +26,5 @@
         [global::System.Configuration.UserScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("00:00:20")]
+        [global::System.Configuration.DefaultSettingValueAttribute("00:00:40")]
         public global::System.TimeSpan HeartbeatInterval {
             get {
@@ -299,4 +299,16 @@
             }
         }
+        
+        [global::System.Configuration.UserScopedSettingAttribute()]
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        [global::System.Configuration.DefaultSettingValueAttribute("-1")]
+        public int NrOfCoresToScavenge {
+            get {
+                return ((int)(this["NrOfCoresToScavenge"]));
+            }
+            set {
+                this["NrOfCoresToScavenge"] = value;
+            }
+        }
     }
 }
Index: /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.settings
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.settings	(revision 7776)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.settings	(revision 7777)
@@ -4,5 +4,5 @@
   <Settings>
     <Setting Name="HeartbeatInterval" Type="System.TimeSpan" Scope="User">
-      <Value Profile="(Default)">00:00:20</Value>
+      <Value Profile="(Default)">00:00:40</Value>
     </Setting>
     <Setting Name="LastUsedFileName" Type="System.String" Scope="User">
@@ -72,4 +72,7 @@
       <Value Profile="(Default)">00:00:20</Value>
     </Setting>
+    <Setting Name="NrOfCoresToScavenge" Type="System.Int32" Scope="User">
+      <Value Profile="(Default)">-1</Value>
+    </Setting>
   </Settings>
 </SettingsFile>
Index: /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/app.config
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/app.config	(revision 7776)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/app.config	(revision 7777)
@@ -51,5 +51,5 @@
     <HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
       <setting name="HeartbeatInterval" serializeAs="String">
-        <value>00:00:20</value>
+        <value>00:00:40</value>
       </setting>
       <setting name="LastUsedFileName" serializeAs="String">
@@ -119,4 +119,7 @@
         <value>00:00:20</value>
       </setting>
+      <setting name="NrOfCoresToScavenge" serializeAs="String">
+        <value>-1</value>
+      </setting>
     </HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
   </userSettings>